routes/web.php
<?php

use Illuminate\Support\Facades\Route;
// use App\Http\Controllers\HomeController;
use App\Http\Controllers\WelcomeController;
use App\Http\Controllers\NotificationController;

use App\Http\Controllers\Admin\DashboardController;
use App\Http\Controllers\Admin\ProfileController;

use App\Http\Controllers\Admin\FloorController;
use App\Http\Controllers\Admin\SectorController;
use App\Http\Controllers\Admin\DeskController;
use App\Http\Controllers\Admin\UserController;
use App\Http\Controllers\Admin\SubscriptionController;
use App\Http\Controllers\Admin\OrderController;

use App\Http\Controllers\Admin\BookingController;
use App\Http\Controllers\Admin\AssessmentController;

use App\Http\Controllers\User\PageController;
use App\Http\Controllers\User\ProfileuController;
use App\Http\Controllers\User\BuyController;
use App\Http\Controllers\User\DashboarduController;
use App\Http\Controllers\User\HistoryController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [PageController::class, 'welcome']);
// Route::get('/dashboard/{username}',[PageController::class, 'dashboard']);

Route::get('/admin', [WelcomeController::class, 'index'])->name('welcome');
Route::get('/synapsis', [WelcomeController::class, 'synapsis']);
Route::get('/activitymonth', [WelcomeController::class, 'activityMonth']);
Route::get('/logmonth', [WelcomeController::class, 'logMonth']);
// Route::get('/notification', [UserController::class, 'notification']);

Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

$router->group(['prefix' => 'user', 'middleware' => 'is_user'], function () use ($router) {
    Route::get('profile', [ProfileuController::class, 'index'])->name('user.profile.index');
    Route::post('profile/{user}', [ProfileuController::class, 'update'])->name('user.profile.update');

    Route::get('dashboard/', [DashboarduController::class, 'index'])->name('user.dashboard');

    Route::get('history/', [HistoryController::class, 'index'])->name('user.history');
    Route::get('history/{id}', [HistoryController::class, 'show'])->name('user.history.show');

    Route::get('buy/', [BuyController::class, 'index'])->name('user.buy');
    Route::post('buy/store', [BuyController::class, 'store'])->name('user.buy.store');
});

$router->group(['prefix' => 'admin', 'middleware' => 'is_admin'], function () use ($router) {
    Route::get('dashboard', [DashboardController::class, 'index'])->name('admin.dashboard');

    Route::get('profile', [ProfileController::class, 'index'])->name('profile.index');
    Route::post('profile/{user}', [ProfileController::class, 'update'])->name('profile.update');

    Route::resource('user', UserController::class);
    Route::resource('subscription', SubscriptionController::class);
    Route::resource('order', OrderController::class);

    Route::get('floor/list', [FloorController::class, 'list'])->name('floor.list');
    Route::resource('floor', FloorController::class);

    Route::get('floor/{floor}/sector/list', [SectorController::class, 'list'])->name('floor.sector.list');
    Route::resource('floor.sector', SectorController::class);

    Route::get('floor/{floor}/sector/{sector}/desk/list', [DeskController::class, 'list'])->name('floor.sector.desk.list');
    Route::resource('floor.sector.desk', DeskController::class);

    Route::get('booking', [BookingController::class, 'index'])->name('booking.index');
    Route::get('booking/{booking}', [BookingController::class, 'show'])->name('booking.show');
    Route::get('booking/{booking}/checkout', [BookingController::class, 'checkout'])->name('booking.checkout');

    Route::get('assessment', [AssessmentController::class, 'index'])->name('assessment.index');
});

app/Models/Floor.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Spatie\MediaLibrary\InteractsWithMedia;
use Spatie\MediaLibrary\HasMedia;
use Spatie\MediaLibrary\MediaCollections\Models\Media;

class Floor extends Model implements HasMedia
{
    use HasFactory, InteractsWithMedia;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name',
        'description',
    ];

    public function sectors()
    {
        return $this->hasMany('App\Models\Sector');
    }
}

app/Http/Controllers/Admin/FloorController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Floor;
use Illuminate\Http\Request;

class FloorController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        // $floors = Floor::all();
        // return view('admin.floor.index')->with(compact('floors'));
        return view('admin.floor.index');
    }

    /**
     * A list of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function list()
    {
        $floors = Floor::all();
        $floors->count = $this->countDataFloor($floors);

        return response()->json(['data' => $floors]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.floor.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        // rules validator
        $validate = $request->validate([
            'name'          => ['required', 'string', 'max:255'],
            'description'   => ['nullable', 'string', 'max:255'],
        ]);

        // create new floor
        $floor = Floor::create([
            'name'          => $request->name,
            'description'   => $request->description,
        ]);

        if ($request->hasFile('file')) {
            $floor->addMediaFromRequest('file')->usingFileName($request->file('file')->hashName())->toMediaCollection('maps');
        }

        return redirect()->route('floor.index')
            ->with('success', 'Floor created successfully.');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Floor  $floor
     * @return \Illuminate\Http\Response
     */
    public function show(Floor $floor)
    {
        // return view('admin.floor.show')->with(compact('floor'));
        // return redirect()->route('sector.index')
        //     ->with(compact('floor'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Floor  $floor
     * @return \Illuminate\Http\Response
     */
    public function edit(Floor $floor)
    {
        $media = $floor->getMedia();

        return view('admin.floor.edit')->with(compact('floor'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Floor  $floor
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Floor $floor)
    {
        $validate = $request->validate([
            'name' => ['required'],
        ]);
        $floor->update($request->all());

        $media = $floor->getMedia();
        if ($request->hasFile('file')) {
            try {
                // delete old media
                $floor->media[0]->delete();
            } catch (\Throwable $th) {
                //
            }
            // create new media
            $floor->addMediaFromRequest('file')->usingFileName($request->file('file')->hashName())->toMediaCollection('maps');
        }

        return redirect()->route('floor.index')
            ->with('success', 'Floor updated successfully.');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Floor  $floor
     * @return \Illuminate\Http\Response
     */
    public function destroy(Floor $floor)
    {
        $floor->delete();

        return redirect()->route('floor.index')
            ->with('success', 'Floor deleted successfully.');
    }

    /**
     * @todo count sectors and desks based floor id
     * @param Array $floors
     */
    private function countDataFloor($floors)
    {
        //count sectors and desks based floor id
        foreach ($floors as $floor) {
            //count sector
            $floor->number_of_sectors = $floor->sectors()->count();
            //condition statement
            if ($floor->number_of_sectors == 0) {
                $floor->number_of_desks = 0;
            }
            //count desks
            foreach ($floor->sectors()->get() as $sector) {
                $floor->number_of_desks += $sector->desks()->count();
            }
        }

        return $floors;
    }
}

app/Http/Controllers/Api/FloorController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\Floor;

class FloorController extends ApiController
{
    /**
     * A list of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $floors = Floor::all();
        // $floors->count = $this->countDataFloor($floors);

        foreach ($floors as $floor) {
            $media = $floor->getMedia();
            try {
                if ($floor->media[0]->hasGeneratedConversion('thumb')) {
                    $floor->media_url = $floor->media[0]->getUrl('thumb');
                } else {
                    $floor->media_url = $floor->media[0]->getUrl();
                }
            } catch (\Throwable $th) {
                //throw $th;
            }
            unset($floor->media);
        }

        return $this->sendResponse('Floors listed succesfully', $floors);
    }
}

resources/views/admin/floor/create.blade.php
@extends('admin.layouts.admin')

@section('style')
    <link href="{{ asset('fileinput/css/fileinput.min.css') }}" rel="stylesheet">
@endsection

@section('content')
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{ route('floor.index') }}">Floor List</a></li>
            <li class="breadcrumb-item active" aria-current="page">New Floor</li>
        </ol>
    </nav>

    <div class="row">
        <div class="col"></div>
        <div class="col-lg-6">
            <div class="card shadow mb-4">
                <div class="card-header py-3">
                    <h5 class="m-0 font-weight-bold text-primary">Create New Floor</h5>
                </div>
                <div class="card-body">
                    @if (count($errors) > 0)
                        <p class="card-description">
                        <div class="alert alert-danger">
                            <ul>
                                @foreach ($errors->all() as $error)
                                    <li>{{ $error }}</li>
                                @endforeach
                            </ul>
                        </div>
                        </p>
                    @endif
                    <form action="{{ route('floor.store') }}" method="POST" enctype="multipart/form-data">
                        @csrf
                        <div class="form-group">
                            <label for="name">Name</label>
                            <input type="text" class="form-control" id="name" name="name" autofocus
                                value="{{ old('name') }}">
                        </div>
                        <div class="form-group">
                            <label for="description">Description</label>
                            <textarea class="form-control" id="description" name="description" cols="30" rows="4"
                                style="resize: none;">{{ old('description') }}</textarea>
                        </div>
                        <div class="form-group">
                            <label for="description">Map (.svg)</label>
                            <input type="file" class="form-control" id="file" name="file">
                        </div>
                        <div class="row mb-1">
                            <div class="col">
                                <div class="d-flex justify-content-end text-align-center flex-column flex-md-row">
                                    {{-- <a type="button" href="{{action('CategoryController@index')}}" class="btn btn-outline-secondary mb-2 mb-lg-0 mb-md-0 mr-0 mr-md-2 mr-lg-2">@lang('general.cancel')</a> --}}
                                    <a type="button" href="javascript:;" onclick="history.back()"
                                        class="btn btn-outline-secondary mb-2 mb-lg-0 mb-md-0 mr-0 mr-md-2 mr-lg-2">Cancel</a>
                                    <button type="submit" class="btn btn-primary"><strong>Create</strong></button>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
        <div class="col"></div>
    </div>
@endsection

@section('script')
    <script src="{{ asset('fileinput/js/fileinput.min.js') }}"></script>
    <script src="{{ asset('fileinput/themes/fa/theme.min.js') }}"></script>
    <script type="text/javascript">
        $("#file").fileinput({
            theme: 'fa',
            showUpload: false,
            showClose: false,
            showCancel: false,
            allowedFileExtensions: ['jpg', 'png', 'gif', 'svg'],
            overwriteInitial: false,
            maxFileSize: 2000,
            maxFilesNum: 10,
            slugCallback: function(filename) {
                return filename.replace('(', '_').replace(']', '_');
            }
        });
    </script>
@endsection

resources/views/admin/floor/edit.blade.php
@extends('admin.layouts.admin')

@section('style')
    <link href="{{ asset('fileinput/css/fileinput.min.css') }}" rel="stylesheet">
@endsection

@section('content')
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{ route('floor.index') }}">Floor List</a></li>
            <li class="breadcrumb-item active" aria-current="page">{{ $floor->name }}</li>
        </ol>
    </nav>

    <div class="row">
        <div class="col"></div>
        <div class="col-lg-6">
            <div class="card shadow mb-4">
                <div class="card-header py-3">
                    <h5 class="m-0 font-weight-bold text-primary">Edit Floor</h5>
                </div>
                <div class="card-body">
                    @if (count($errors) > 0)
                        <p class="card-description">
                        <div class="alert alert-danger">
                            <ul>
                                @foreach ($errors->all() as $error)
                                    <li>{{ $error }}</li>
                                @endforeach
                            </ul>
                        </div>
                        </p>
                    @endif
                    <form action="{{ route('floor.update', $floor->id) }}" method="POST" enctype="multipart/form-data">
                        @csrf
                        @method('PUT')
                        <div class="form-group">
                            <label for="name">Name</label>
                            <input type="text" class="form-control" id="name" name="name" autofocus
                                value="{{ old('name') ? old('name') : $floor->name }}">
                        </div>
                        <div class="form-group">
                            <label for="description">Description</label>
                            <textarea class="form-control" id="description" name="description" cols="30" rows="4"
                                style="resize: none;">{{ old('description') ? old('description') : $floor->description }}</textarea>
                        </div>
                        <div class="form-group">
                            <label for="description">Map (.svg)</label>
                            <input type="file" class="form-control" id="file" name="file">
                        </div>
                        <div class="row mb-1">
                            <div class="col">
                                <div class="d-flex justify-content-end text-align-center flex-column flex-md-row">
                                    <a type="button" href="javascript:;" onclick="history.back()"
                                        class="btn btn-outline-secondary mb-2 mb-lg-0 mb-md-0 mr-0 mr-md-2 mr-lg-2">Cancel</a>
                                    <button type="submit" class="btn btn-primary"><strong>Update</strong></button>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
        <div class="col"></div>
    </div>
@endsection

@section('script')
    <script src="{{ asset('fileinput/js/fileinput.min.js') }}"></script>
    <script src="{{ asset('fileinput/themes/fa/theme.min.js') }}"></script>
    <script type="text/javascript">
        var imageUrl = "{{ $floor->getFirstMediaUrl('maps', 'thumb') }}";
        if (imageUrl != "") {
            var initialPreview = [
                "{{ $floor->getFirstMediaUrl('maps', 'thumb') }}",
            ];
            var initialPreviewConfig = [{
                type: "image",
                caption: "{{ isset($floor->media[0]) ? $floor->media[0]->file_name : '' }}",
                size: "{{ isset($floor->media[0]) ? $floor->media[0]->size : '' }}",
                // url: "/site/file-delete",
                key: 1
            }, ];
            $("#file").fileinput({
                theme: 'fa',
                showUpload: false,
                showClose: false,
                showCancel: false,
                showRemove: false,
                allowedFileExtensions: ['svg', 'jpg', 'png'],
                // overwriteInitial: false,
                autoReplace: true,
                overwriteInitial: true,
                showUploadedThumbs: false,
                maxFileCount: 1,
                initialPreview: initialPreview,
                initialPreviewAsData: true,
                initialPreviewConfig: initialPreviewConfig,
                initialPreviewFileType: 'image',
                initialPreviewShowDelete: false,
                maxFileSize: 2000,
                maxFilesNum: 10,
                slugCallback: function(filename) {
                    return filename.replace('(', '_').replace(']', '_');
                }
            });
        } else {
            $("#file").fileinput({
                theme: 'fa',
                showUpload: false,
                showClose: false,
                showCancel: false,
                allowedFileExtensions: ['svg', 'jpg', 'png'],
                overwriteInitial: false,
                maxFileCount: 1,
                // initialPreview: initialPreview,
                initialPreviewAsData: true,
                // initialPreviewConfig: initialPreviewConfig,
                initialPreviewFileType: 'image',
                initialPreviewShowDelete: false,
                maxFileSize: 2000,
                maxFilesNum: 10,
                slugCallback: function(filename) {
                    return filename.replace('(', '_').replace(']', '_');
                }
            });
        }
    </script>
@endsection

resources/views/admin/floor/index.blade.php
@extends('admin.layouts.admin')

@section('style')
    {{-- Datatables --}}
    <link href="{{ asset('datatables/dataTables.bootstrap4.min.css') }}" rel="stylesheet" type="text/css">
    <link href="{{ asset('datatables/responsive/css/responsive.bootstrap4.min.css') }}" rel="stylesheet" type="text/css">
    <style>
        #table {
            table-layout: fixed;
            width: 99% !important;
        }

        #table tbody td {
            display: block;
            border: unset;
        }

        #table>tbody>tr>td {
            border-top: unset;
        }

        .card-text {
            white-space: nowrap;
            overflow: hidden;
            text-overflow: ellipsis;
        }

        .btn-secondary:hover,
        .btn-secondary:focus,
        .btn-secondary:active,
        .btn-secondary.active,
        .open>.dropdown-toggle.btn-secondary {
            background-color: #366bbd;
        }

        .toolbar {
            float: left;
        }
    </style>
@endsection

@section('content')
    @if ($message = Session::get('success'))
        <div class="alert alert-dismissable alert-success">
            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
            <span>{{ $message }}</span>
        </div>
    @elseif ($message = Session::get('error'))
        <div class="alert alert-dismissable alert-danger">
            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
            <span>{{ $message }}</span>
        </div>
    @endif

    <div class="row">
        <div class="col">
            <div class="card shadow mb-4">
                <div class="card-header"><strong>Floor List</strong></div>
                <div class="card-body">
                    <div class="table-responsive">
                        <table class="table table-bordered display responsive nowrap" id="table" cellspacing="0">
                            <thead>
                                <tr>
                                    <th>#</th>
                                    <th>ID</th>
                                    <th>Name</th>
                                    <th>Description</th>
                                </tr>
                            </thead>
                            <tbody>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- Modal -->
    <div id="deleteModal" class="modal fade" role="dialog">
        <div class="modal-dialog">
            <!-- Modal content-->
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Delete</h5>
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                    <p>Are you sure want to delete this floor?</p>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-outline-secondary" data-dismiss="modal">No</button>
                    <form action="#" method="POST" id="deleteForm">
                        @csrf
                        @method('DELETE')
                        <button type="submit" class="btn btn-danger" id="delete-btn"><strong>Yes, delete</strong></button>
                    </form>
                </div>
            </div>
        </div>
    </div>
@endsection

@section('script')
    {{-- Datatable --}}
    <script src="{{ asset('datatables/jquery.dataTables.min.js') }}"></script>
    <script src="{{ asset('datatables/dataTables.bootstrap4.min.js') }}"></script>
    <script src="{{ asset('datatables/responsive/js/dataTables.responsive.min.js') }}"></script>
    <script src="{{ asset('datatables/responsive/js/responsive.bootstrap4.min.js') }}"></script>
    <script src="{{ asset('datatables/sorting/natural.js') }}"></script>

    <script type="text/javascript">
        $(document).ready(function() {
            $("#table thead").hide();
            let url_list = "{{ route('floor.list') }}";
            let url_create = "{{ route('floor.create') }}";
            var dt = $('#table').DataTable({
                ajax: url_list,
                bInfo: false,
                pageLength: 12,
                lengthChange: false,
                deferRender: true,
                processing: true,
                dom: 'l<"toolbar">frtip',
                initComplete: function() {
                    $("div.toolbar")
                        .html(
                            '<a href="' + url_create +
                            '" type="button" class="btn btn-primary btn-block"><i class="fas fa-plus"></i> Create New</a>'
                        );
                },
                language: {
                    paginate: {
                        previous: "<",
                        next: ">"
                    },
                },
                columns: [{
                        render: function(data, type, row, meta) {
                            let id = row.id;

                            let url_show = "{{ route('floor.show', ':id') }}";
                            url_show = url_show.replace(':id', row.id) + '/sector';

                            let url_edit = "{{ route('floor.edit', ':id') }}";
                            url_edit = url_edit.replace(':id', row.id);

                            var sector = (row.number_of_sectors == 0 || row.number_of_sectors ==
                                1) ? ' sector' : ' sectors';
                            var desk = (row.number_of_desks == 0 || row.number_of_desks ==
                                1) ? ' desk' : ' desks';

                            // var media = "";
                            // if (row.getMediaUrl[0]) {
                            //     var media = row.getMediaUrl[0];
                            // }

                            var html =
                                '<div class="card shadow">' +
                                // '  <img src="' + row.getMediaUrl[0] + '" class="card-img-top">' +
                                // '   <div class="card-header">' + row.name + '</div>' +
                                '   <div class="card-body">' +
                                '       <div class="float-right">' +
                                '           <div class="dropdown">' +
                                '               <a class="btn dropdown" type="button" id="dropdownMenuButton"' +
                                '                   data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">' +
                                '                   <i class="fas fa-ellipsis-v"></i></a>' +
                                '               <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">' +
                                '                   <a class="dropdown-item" href="' + url_edit +
                                '                       "><i class="fas fa-pencil-alt"></i> Edit</a>' +
                                '                   <a class="dropdown-item" href="#" data-toggle="modal" data-target="' +
                                '                       #deleteModal" data-id="' + row.id +
                                '                       "><i class="fas fa-trash"></i> Delete</a>' +
                                '               </div>' +
                                '           </div>' +
                                '       </div>' +
                                '       <div class="card-text"><strong>' + row.name +
                                '           </strong></div>' +
                                '       <p class="card-text">' + row.description +
                                '           <br> <i class="fas fa-chart-pie"></i> ' + row
                                .number_of_sectors + sector + '<br> <i class="fas fa-chair"></i> ' +
                                row.number_of_desks + desk +
                                '           </p>' +
                                '       <a href="' + url_show +
                                '           "type="button" class="btn btn-secondary btn-block"><i class="fas fa-eye"></i> Show</a>' +
                                '   </div>' +
                                '</div>'

                            return html;
                        }
                    },
                    {
                        data: "name",
                        visible: false
                    },
                ]
            });

            dt.on('draw', function(data) {
                $('#table tbody').addClass('row');
                $('#table tbody tr').addClass('col-lg-3 col-md-4 col-sm-12');
            });
        });

        $('#deleteModal').on('show.bs.modal', function(event) {
            var button = $(event.relatedTarget); // Button that triggered the modal
            var id = button.data('id'); // Extract info from data-* attributes
            // Update the modal's content. We'll use jQuery here, but you could use a data binding library or other methods instead.
            var modal = $(this);
            var form = document.getElementById("deleteForm");
            let url = "{{ route('floor.destroy', ':id') }}";
            url = url.replace(':id', id);
            form.action = url;
        })
    </script>
@endsection